#include <ros/ros.h>
#include <iostream>
#include <cstdlib>
#include <sstream>
#include "std_msgs/Int32.h"

int mode = 0x04;

void callback(const std_msgs::Int32 &data)
{
    std::stringstream ss;
    if (data.data == 1)
    {
        ss << "cansend can0 100#0100000000000000";
        mode = 0x01;
    }

    else if (data.data == 2)
    {
        ss << "cansend can0 100#0200000000000000";
        mode = 0x02;
    }
    else if (data.data == 3)
    {
        ss << "cansend can0 100#0300000000000000";
        mode = 0x03;
    }
    else if (data.data == 4)
    {
        ss << "cansend can0 100#0400000000000000";
        mode = 0x04;
    }
    else if (data.data == 5)
    {
        ss << "cansend can0 100#0500000000000000";
        mode = 0x05;
    }
    else if (data.data == 6)
        ss << "cansend can0 100#0000000000010000";

    int res = std::system(ss.str().c_str());
    if (res != 0)
        ROS_ERROR("Failed to execute command: %s", ss.str().c_str());

    ros::param::set("mode", mode);
}

int main(int argc, char **argv)
{
    ros::init(argc, argv, "change_mode_subscriber");
    ros::NodeHandle nh;
    ros::Subscriber sub = nh.subscribe("change_mode", 1, callback);
    ros::spin();
    return 0;
}